import es
import gamethread
import time
import cmdlib
import soccer.soccer as soccerlib
from usermsg import hudhint
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Sprint Script"
info.version = soccerlib.info.version
info.basename = "soccersprint"
info.author = "chrismrulz"

sprint_length = time.strptime(soccerlib.config["Sprint"]["length"], "%M:%S")
sprint_length = int(time.strftime('%M', sprint_length)) * 60 + int(time.strftime('%S', sprint_length))
sprint_cooldown = time.strptime(soccerlib.config["Sprint"]["cooldown"], "%M:%S")
sprint_cooldown = int(time.strftime('%M', sprint_cooldown)) * 60 + int(time.strftime('%S', sprint_cooldown))
sprint_speed = soccerlib.config["Sprint"]["speed"]
sprint_msgs = int(soccerlib.config["Sprint"]["msgs"])
sprint_msgmode = int(soccerlib.config["Sprint"]["msgmode"])
sprint_sprintsound = soccerlib.config["Sprint"]["sprintsound"]
sprint_readysound = soccerlib.config["Sprint"]["readysound"]
sprint_endsound = soccerlib.config["Sprint"]["endsound"]
sprint_waitsound = soccerlib.config["Sprint"]["waitsound"]
sprint_publicsound = soccerlib.config["Sprint"]["publicsound"]

soccerlib.addsound(sprint_sprintsound)
soccerlib.addsound(sprint_readysound)
soccerlib.addsound(sprint_endsound)
soccerlib.addsound(sprint_waitsound)
soccerlib.addsound(sprint_publicsound)

def load():
  es.msg('#Green', 'Soccer Sprint Script On - by Toph')
  loadblock()

def unload():
  cmdlib.unregisterClientCommand('sprint')
  cmdlib.unregisterSayCommand('!sprint')
  es.msg('#Green', 'Soccer Sprint Script Off')

def es_map_start(event_var):
  loadblock()

def loadblock():
	if(es.exists('clientcommand', 'sprint') != 1):
		cmdlib.registerClientCommand('sprint', sprint, 'Makes the player sprint')
	if(es.exists('saycommand', '!sprint') != 1):
		cmdlib.registerSayCommand('!sprint', sprint, 'Makes the player sprint')

def setspeed(userid, speed):
  es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", speed)

def round_start(event_var):
  global lastroundtime
  lastroundtime = int(time.time())
  global lastsprint
  lastsprint = {}

def getmsgs(steamid):
	if(steamid not in soccerlib.players):
		return sprint_msgs
	else:
		if('sprintmsgs' not in soccerlib.players[steamid]):
			return sprint_msgs
		else:
			return soccerlib.players[steamid]['sprintmsgs']

def getmsgmode(steamid):
	if(steamid not in soccerlib.players):
		return sprint_msgmode
	else:
		if('sprintmsgmode' not in soccerlib.players[steamid]):
			return sprint_msgmode
		else:
			return soccerlib.players[steamid]['sprintmsgmode']
  
def sprintmsg(userid, steamid, time, msg):
  if(time > lastroundtime):
    usprint_msgmode = getmsgmode(steamid)
    if(usprint_msgmode == 0):
      es.menu(sprint_cooldown, userid, msg)
    elif(usprint_msgmode == 1):
      hudhint(userid, msg)
    elif(usprint_msgmode == 2):
      es.tell(userid, "#green", msg)

def getsprintsounds(steamid):
	if(steamid not in soccerlib.players):
		return 0
	else:
		if('sprintsounds' not in soccerlib.players[steamid]):
			return 0
		else:
			return soccerlib.players[steamid]['sprintsounds']

def sprint(userid, args):
  global lastsprint
  sprint_steamid = es.getplayersteamid(userid)
  if(lastsprint == {} or sprint_steamid not in lastsprint):
    lastsprint[sprint_steamid] = 0
  thesprinttime = int(time.time())
  usprint_msgs = getmsgs(sprint_steamid)
  if(thesprinttime > int(lastsprint[sprint_steamid])):
    if(usprint_msgs != 0):
      sprintmsg(userid, sprint_steamid, thesprinttime, "You are now using sprint.")
      if(sprint_sprintsound and getsprintsounds(sprint_steamid) == 0):
        es.playsound(userid, sprint_sprintsound, 1)
      if(sprint_publicsound):
        es.emitsound("player", userid, sprint_publicsound, 1, 0.7)
    setspeed(userid, sprint_speed)
    gamethread.delayed(sprint_length, setspeed, (userid, 1))
    if(usprint_msgs == 2):
      gamethread.delayed(sprint_length, sprintmsg, (userid, sprint_steamid, thesprinttime, "Your sprint has now ended."))
      if(sprint_endsound and getsprintsounds(sprint_steamid) == 0):
        gamethread.delayed(sprint_length, es.playsound, (userid, sprint_endsound, 1))
    lastsprint[sprint_steamid] = (thesprinttime + sprint_length + sprint_cooldown)
    if(usprint_msgs != 0):
      gamethread.delayed(sprint_length + sprint_cooldown, sprintmsg, (userid, sprint_steamid, thesprinttime, "You can now use sprint again."))
      if(sprint_readysound and getsprintsounds(sprint_steamid) == 0):
        gamethread.delayed(sprint_length + sprint_cooldown, es.playsound, (userid, sprint_readysound, 1))
  elif(usprint_msgs != 0):
    sprintmsg(userid, sprint_steamid, thesprinttime, "You have %i seconds until you can sprint again." % int(lastsprint[sprint_steamid] - int(thesprinttime)))
    if(sprint_waitsound and getsprintsounds(sprint_steamid) == 0):
      es.playsound(userid, sprint_waitsound, 1)